//+------------------------------------------------------------------+
//|                                                 N&P with Tim.mq4 |
//|                                                  Nick Lougovskoi |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Nick Lougovskoi"
#property link "http://www.metaquotes.net"
//----
extern bool BuyFlag = true;   
extern bool SellFlag = true;  
extern double TopFilter_Ok;
extern double BotFilter_Ok;
extern double Lots = 0.01;
extern int TakeProfit = 20;
//----

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }



//-------------------Overview of Program Design






//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{

double ema7,ema14,sma50;						//move these up alongside your extern variables declarations for now
string sSignal;								// "
int iOrders;								// "
int iDuplicateOrders;							// "
  
//----------------Variable Declaration-------------------------+

   ema7 = iMA(Symbol(),PERIOD_M5,7,0,MODE_EMA,PRICE_CLOSE,0);      	// This is not "declaration" of variables - its is setting them.
   ema14 = iMA(Symbol(),PERIOD_M5,14,0,MODE_EMA,PRICE_CLOSE,0);   	 //  "
   sma50 = iMA(Symbol(),PERIOD_M5,50,0,MODE_SMA,PRICE_CLOSE,0);    	//  "
   
//-------------------------------------------------------------+
   {
   string fnGenerateSignal; 						// remove this line - these functions are declared with their own code blocks (below)
   int fnTrade; 							// and this one
   sSignal = fnGenerateSignal;						// change this to "sGignal = fnGenerateSignal();"
   if (fnShouldWeTrade())
    fnTrade;                                                            // change this to "fnTrade();"
   return(0);
  }
//+------------------------------------------------------------------+
//| Nick's functions                                                 |
//+------------------------------------------------------------------+
string fnGenerateSignal ()						//change this to "string fnGenerateSignal()"
 {
  if((ema7>ema14)&&(ema14>sma50)&&(Ask<TopFilter_Ok))
     return("OP_BUY");
  if((ema7<ema14)&&(ema14<sma50)&&(Bid>BotFilter_Ok))		
    return("OP_SELL");
  return("PASS");
 }
//-----------------
bool fnShouldWeTrade(string sSignal, bool BuyFlag, bool SellFlag, bool fnOrderDuplicate) //change this to "bool fnShouldWeTrade()"
 {
 if ((sSignal != "OP_BUY") && (sSignal != "OP_SELL"))
  return(false); 
 if (sSignal == "OP_BUY")
  if (!BuyFlag)
   return(false);
 if (sSignal == "OP_SELL")
  if(!SellFlag)
   return(false);
 if (fnOrderDuplicate())
  return(false);
 return(true);
 }
//-----------------------------------------------------+


bool fnOrderDuplicate(int iDuplicateOrders, int iOrders, string sSignal)	//change this to "bool fnOrderDuplicate()"
 {
  iDuplicateOrders = 0;
  iOrders = OrdersTotal()-1;
  for (int i=iOrders; i>=0; i--)
   {
    OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
    if ((OrderSymbol() == Symbol()) && (OrderType() == sSignal))
        iDuplicateOrders++;
   }
  if (iDuplicateOrders == 0)
   return(false);
  return(true);
 }





//----
int fnTrade(string sSignal)							//change this to "int fnTrade()"
 {
  if (sSignal == "OP_BUY")
   OrderSend(Symbol(),sSignal,Lots,Ask,5,0,Bid+TakeProfit*Point,"Nikos First EA",0,0,Green);
  else
   OrderSend(Symbol(),sSignal,Lots,Bid,5,0,Bid+TakeProfit*Point,"Nikos First EA",0,0,Green);
  return(0);
 }
 return(0);									//remove this
 }										//and this (this is your unbalanced parenthesis)
//---- THE END ----